from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class RecordingList(ListResource):
    def __init__(self, version, account_sid, call_sid) -> None: ...
    def create(self, recording_status_callback_event=..., recording_status_callback=..., recording_status_callback_method=..., trim=..., recording_channels=..., recording_track=...): ...
    def stream(self, date_created_before=..., date_created=..., date_created_after=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, date_created_before=..., date_created=..., date_created_after=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, date_created_before=..., date_created=..., date_created_after=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class RecordingPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class RecordingContext(InstanceContext):
    def __init__(self, version, account_sid, call_sid, sid) -> None: ...
    def update(self, status, pause_behavior=...): ...
    def fetch(self): ...
    def delete(self): ...

class RecordingInstance(InstanceResource):
    class Status:
        IN_PROGRESS: str
        PAUSED: str
        STOPPED: str
        PROCESSING: str
        COMPLETED: str
        ABSENT: str
    class Source:
        DIALVERB: str
        CONFERENCE: str
        OUTBOUNDAPI: str
        TRUNKING: str
        RECORDVERB: str
        STARTCALLRECORDINGAPI: str
        STARTCONFERENCERECORDINGAPI: str
    def __init__(self, version, payload, account_sid, call_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def api_version(self): ...
    @property
    def call_sid(self): ...
    @property
    def conference_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def start_time(self): ...
    @property
    def duration(self): ...
    @property
    def sid(self): ...
    @property
    def price(self): ...
    @property
    def uri(self): ...
    @property
    def encryption_details(self): ...
    @property
    def price_unit(self): ...
    @property
    def status(self): ...
    @property
    def channels(self): ...
    @property
    def source(self): ...
    @property
    def error_code(self): ...
    @property
    def track(self): ...
    def update(self, status, pause_behavior=...): ...
    def fetch(self): ...
    def delete(self): ...
