from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class TranscriptionList(ListResource):
    def __init__(self, version, account_sid, recording_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class TranscriptionPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class TranscriptionContext(InstanceContext):
    def __init__(self, version, account_sid, recording_sid, sid) -> None: ...
    def fetch(self): ...
    def delete(self): ...

class TranscriptionInstance(InstanceResource):
    class Status:
        IN_PROGRESS: str
        COMPLETED: str
        FAILED: str
    def __init__(self, version, payload, account_sid, recording_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def api_version(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def duration(self): ...
    @property
    def price(self): ...
    @property
    def price_unit(self): ...
    @property
    def recording_sid(self): ...
    @property
    def sid(self): ...
    @property
    def status(self): ...
    @property
    def transcription_text(self): ...
    @property
    def type(self): ...
    @property
    def uri(self): ...
    def fetch(self): ...
    def delete(self): ...
