from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.api.v2010.account.sip.domain.auth_types import AuthTypesList as AuthTypesList
from twilio.rest.api.v2010.account.sip.domain.credential_list_mapping import CredentialListMappingList as CredentialListMappingList
from twilio.rest.api.v2010.account.sip.domain.ip_access_control_list_mapping import IpAccessControlListMappingList as IpAccessControlListMappingList

class DomainList(ListResource):
    def __init__(self, version, account_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, domain_name, friendly_name=..., voice_url=..., voice_method=..., voice_fallback_url=..., voice_fallback_method=..., voice_status_callback_url=..., voice_status_callback_method=..., sip_registration=..., emergency_calling_enabled=..., secure=..., byoc_trunk_sid=..., emergency_caller_sid=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class DomainPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class DomainContext(InstanceContext):
    def __init__(self, version, account_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, friendly_name=..., voice_fallback_method=..., voice_fallback_url=..., voice_method=..., voice_status_callback_method=..., voice_status_callback_url=..., voice_url=..., sip_registration=..., domain_name=..., emergency_calling_enabled=..., secure=..., byoc_trunk_sid=..., emergency_caller_sid=...): ...
    def delete(self): ...
    @property
    def ip_access_control_list_mappings(self): ...
    @property
    def credential_list_mappings(self): ...
    @property
    def auth(self): ...

class DomainInstance(InstanceResource):
    def __init__(self, version, payload, account_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def api_version(self): ...
    @property
    def auth_type(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def domain_name(self): ...
    @property
    def friendly_name(self): ...
    @property
    def sid(self): ...
    @property
    def uri(self): ...
    @property
    def voice_fallback_method(self): ...
    @property
    def voice_fallback_url(self): ...
    @property
    def voice_method(self): ...
    @property
    def voice_status_callback_method(self): ...
    @property
    def voice_status_callback_url(self): ...
    @property
    def voice_url(self): ...
    @property
    def subresource_uris(self): ...
    @property
    def sip_registration(self): ...
    @property
    def emergency_calling_enabled(self): ...
    @property
    def secure(self): ...
    @property
    def byoc_trunk_sid(self): ...
    @property
    def emergency_caller_sid(self): ...
    def fetch(self): ...
    def update(self, friendly_name=..., voice_fallback_method=..., voice_fallback_url=..., voice_method=..., voice_status_callback_method=..., voice_status_callback_url=..., voice_url=..., sip_registration=..., domain_name=..., emergency_calling_enabled=..., secure=..., byoc_trunk_sid=..., emergency_caller_sid=...): ...
    def delete(self): ...
    @property
    def ip_access_control_list_mappings(self): ...
    @property
    def credential_list_mappings(self): ...
    @property
    def auth(self): ...
