from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class IpAddressList(ListResource):
    def __init__(self, version, account_sid, ip_access_control_list_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, friendly_name, ip_address, cidr_prefix_length=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class IpAddressPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class IpAddressContext(InstanceContext):
    def __init__(self, version, account_sid, ip_access_control_list_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, ip_address=..., friendly_name=..., cidr_prefix_length=...): ...
    def delete(self): ...

class IpAddressInstance(InstanceResource):
    def __init__(self, version, payload, account_sid, ip_access_control_list_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def ip_address(self): ...
    @property
    def cidr_prefix_length(self): ...
    @property
    def ip_access_control_list_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def uri(self): ...
    def fetch(self): ...
    def update(self, ip_address=..., friendly_name=..., cidr_prefix_length=...): ...
    def delete(self): ...
