from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class UserChannelList(ListResource):
    def __init__(self, version, service_sid, user_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, channel_sid): ...
    def __call__(self, channel_sid): ...

class UserChannelPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class UserChannelContext(InstanceContext):
    def __init__(self, version, service_sid, user_sid, channel_sid) -> None: ...
    def fetch(self): ...
    def delete(self, x_twilio_webhook_enabled=...): ...
    def update(self, notification_level=..., last_consumed_message_index=..., last_consumption_timestamp=...): ...

class UserChannelInstance(InstanceResource):
    class ChannelStatus:
        JOINED: str
        INVITED: str
        NOT_PARTICIPATING: str
    class NotificationLevel:
        DEFAULT: str
        MUTED: str
    class WebhookEnabledType:
        TRUE: str
        FALSE: str
    def __init__(self, version, payload, service_sid, user_sid, channel_sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def channel_sid(self): ...
    @property
    def user_sid(self): ...
    @property
    def member_sid(self): ...
    @property
    def status(self): ...
    @property
    def last_consumed_message_index(self): ...
    @property
    def unread_messages_count(self): ...
    @property
    def links(self): ...
    @property
    def url(self): ...
    @property
    def notification_level(self): ...
    def fetch(self): ...
    def delete(self, x_twilio_webhook_enabled=...): ...
    def update(self, notification_level=..., last_consumed_message_index=..., last_consumption_timestamp=...): ...
