from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class WebhookList(ListResource):
    def __init__(self, version, conversation_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, target, configuration_url=..., configuration_method=..., configuration_filters=..., configuration_triggers=..., configuration_flow_sid=..., configuration_replay_after=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class WebhookPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class WebhookContext(InstanceContext):
    def __init__(self, version, conversation_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, configuration_url=..., configuration_method=..., configuration_filters=..., configuration_triggers=..., configuration_flow_sid=...): ...
    def delete(self): ...

class WebhookInstance(InstanceResource):
    class Target:
        WEBHOOK: str
        TRIGGER: str
        STUDIO: str
    class Method:
        GET: str
        POST: str
    def __init__(self, version, payload, conversation_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def conversation_sid(self): ...
    @property
    def target(self): ...
    @property
    def url(self): ...
    @property
    def configuration(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    def fetch(self): ...
    def update(self, configuration_url=..., configuration_method=..., configuration_filters=..., configuration_triggers=..., configuration_flow_sid=...): ...
    def delete(self): ...
