from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class RoleList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, friendly_name, type, permission): ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class RolePage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class RoleContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def update(self, permission): ...
    def delete(self): ...
    def fetch(self): ...

class RoleInstance(InstanceResource):
    class RoleType:
        CONVERSATION: str
        SERVICE: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def chat_service_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def type(self): ...
    @property
    def permissions(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    def update(self, permission): ...
    def delete(self): ...
    def fetch(self): ...
