from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.conversations.v1.service.binding import BindingList as BindingList
from twilio.rest.conversations.v1.service.configuration import ConfigurationList as ConfigurationList
from twilio.rest.conversations.v1.service.conversation import ConversationList as ConversationList
from twilio.rest.conversations.v1.service.participant_conversation import ParticipantConversationList as ParticipantConversationList
from twilio.rest.conversations.v1.service.role import RoleList as RoleList
from twilio.rest.conversations.v1.service.user import UserList as UserList

class ServiceList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, friendly_name): ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class ServicePage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class ServiceContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def delete(self): ...
    def fetch(self): ...
    @property
    def conversations(self): ...
    @property
    def bindings(self): ...
    @property
    def users(self): ...
    @property
    def roles(self): ...
    @property
    def configuration(self): ...
    @property
    def participant_conversations(self): ...

class ServiceInstance(InstanceResource):
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def delete(self): ...
    def fetch(self): ...
    @property
    def conversations(self): ...
    @property
    def bindings(self): ...
    @property
    def users(self): ...
    @property
    def roles(self): ...
    @property
    def configuration(self): ...
    @property
    def participant_conversations(self): ...
