from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class BindingList(ListResource):
    def __init__(self, version, chat_service_sid) -> None: ...
    def stream(self, binding_type=..., identity=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, binding_type=..., identity=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, binding_type=..., identity=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class BindingPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class BindingContext(InstanceContext):
    def __init__(self, version, chat_service_sid, sid) -> None: ...
    def delete(self): ...
    def fetch(self): ...

class BindingInstance(InstanceResource):
    class BindingType:
        APN: str
        GCM: str
        FCM: str
    def __init__(self, version, payload, chat_service_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def chat_service_sid(self): ...
    @property
    def credential_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def endpoint(self): ...
    @property
    def identity(self): ...
    @property
    def binding_type(self): ...
    @property
    def message_types(self): ...
    @property
    def url(self): ...
    def delete(self): ...
    def fetch(self): ...
