from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.conversations.v1.service.conversation.message.delivery_receipt import DeliveryReceiptList as DeliveryReceiptList

class MessageList(ListResource):
    def __init__(self, version, chat_service_sid, conversation_sid) -> None: ...
    def create(self, author=..., body=..., date_created=..., date_updated=..., attributes=..., media_sid=..., content_sid=..., content_variables=..., x_twilio_webhook_enabled=...): ...
    def stream(self, order=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, order=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, order=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class MessagePage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class MessageContext(InstanceContext):
    def __init__(self, version, chat_service_sid, conversation_sid, sid) -> None: ...
    def update(self, author=..., body=..., date_created=..., date_updated=..., attributes=..., x_twilio_webhook_enabled=...): ...
    def delete(self, x_twilio_webhook_enabled=...): ...
    def fetch(self): ...
    @property
    def delivery_receipts(self): ...

class MessageInstance(InstanceResource):
    class OrderType:
        ASC: str
        DESC: str
    class WebhookEnabledType:
        TRUE: str
        FALSE: str
    def __init__(self, version, payload, chat_service_sid, conversation_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def chat_service_sid(self): ...
    @property
    def conversation_sid(self): ...
    @property
    def sid(self): ...
    @property
    def index(self): ...
    @property
    def author(self): ...
    @property
    def body(self): ...
    @property
    def media(self): ...
    @property
    def attributes(self): ...
    @property
    def participant_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def delivery(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    @property
    def content_sid(self): ...
    def update(self, author=..., body=..., date_created=..., date_updated=..., attributes=..., x_twilio_webhook_enabled=...): ...
    def delete(self, x_twilio_webhook_enabled=...): ...
    def fetch(self): ...
    @property
    def delivery_receipts(self): ...
