from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.events.v1.sink.sink_test import SinkTestList as SinkTestList
from twilio.rest.events.v1.sink.sink_validate import SinkValidateList as SinkValidateList

class SinkList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, description, sink_configuration, sink_type): ...
    def stream(self, in_use=..., status=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, in_use=..., status=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, in_use=..., status=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class SinkPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class SinkContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, description): ...
    @property
    def sink_test(self): ...
    @property
    def sink_validate(self): ...

class SinkInstance(InstanceResource):
    class Status:
        INITIALIZED: str
        VALIDATING: str
        ACTIVE: str
        FAILED: str
    class SinkType:
        KINESIS: str
        WEBHOOK: str
        SEGMENT: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def description(self): ...
    @property
    def sid(self): ...
    @property
    def sink_configuration(self): ...
    @property
    def sink_type(self): ...
    @property
    def status(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, description): ...
    @property
    def sink_test(self): ...
    @property
    def sink_validate(self): ...
