from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class UserChannelList(ListResource):
    def __init__(self, version: Any, service_sid: Any, user_sid: Any) -> None: ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...

class UserChannelPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class UserChannelInstance(InstanceResource):
    class ChannelStatus:
        JOINED: str = ...
        INVITED: str = ...
        NOT_PARTICIPATING: str = ...
    def __init__(self, version: Any, payload: Any, service_sid: Any, user_sid: Any) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def channel_sid(self): ...
    @property
    def member_sid(self): ...
    @property
    def status(self): ...
    @property
    def last_consumed_message_index(self): ...
    @property
    def unread_messages_count(self): ...
    @property
    def links(self): ...
