from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class MediaRecordingList(ListResource):
    def __init__(self, version) -> None: ...
    def stream(self, order=..., status=..., processor_sid=..., source_sid=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, order=..., status=..., processor_sid=..., source_sid=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, order=..., status=..., processor_sid=..., source_sid=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class MediaRecordingPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class MediaRecordingContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def delete(self): ...
    def fetch(self): ...

class MediaRecordingInstance(InstanceResource):
    class Format:
        MP4: str
        WEBM: str
    class Order:
        ASC: str
        DESC: str
    class Status:
        PROCESSING: str
        COMPLETED: str
        DELETED: str
        FAILED: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def duration(self): ...
    @property
    def format(self): ...
    @property
    def links(self): ...
    @property
    def processor_sid(self): ...
    @property
    def resolution(self): ...
    @property
    def source_sid(self): ...
    @property
    def sid(self): ...
    @property
    def media_size(self): ...
    @property
    def status(self): ...
    @property
    def status_callback(self): ...
    @property
    def status_callback_method(self): ...
    @property
    def url(self): ...
    def delete(self): ...
    def fetch(self): ...
