from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class TollfreeVerificationList(ListResource):
    def __init__(self, version) -> None: ...
    def stream(self, tollfree_phone_number_sid=..., status=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, tollfree_phone_number_sid=..., status=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, tollfree_phone_number_sid=..., status=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, business_name, business_website, notification_email, use_case_categories, use_case_summary, production_message_sample, opt_in_image_urls, opt_in_type, message_volume, tollfree_phone_number_sid, customer_profile_sid=..., business_street_address=..., business_street_address2=..., business_city=..., business_state_province_region=..., business_postal_code=..., business_country=..., additional_information=..., business_contact_first_name=..., business_contact_last_name=..., business_contact_email=..., business_contact_phone=..., external_reference_id=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class TollfreeVerificationPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class TollfreeVerificationContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def fetch(self): ...
    def update(self, business_name=..., business_website=..., notification_email=..., use_case_categories=..., use_case_summary=..., production_message_sample=..., opt_in_image_urls=..., opt_in_type=..., message_volume=..., business_street_address=..., business_street_address2=..., business_city=..., business_state_province_region=..., business_postal_code=..., business_country=..., additional_information=..., business_contact_first_name=..., business_contact_last_name=..., business_contact_email=..., business_contact_phone=...): ...

class TollfreeVerificationInstance(InstanceResource):
    class Status:
        PENDING_REVIEW: str
        IN_REVIEW: str
        TWILIO_APPROVED: str
        TWILIO_REJECTED: str
    class OptInType:
        VERBAL: str
        WEB_FORM: str
        PAPER_FORM: str
        VIA_TEXT: str
        MOBILE_QR_CODE: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def customer_profile_sid(self): ...
    @property
    def trust_product_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def regulated_item_sid(self): ...
    @property
    def business_name(self): ...
    @property
    def business_street_address(self): ...
    @property
    def business_street_address2(self): ...
    @property
    def business_city(self): ...
    @property
    def business_state_province_region(self): ...
    @property
    def business_postal_code(self): ...
    @property
    def business_country(self): ...
    @property
    def business_website(self): ...
    @property
    def business_contact_first_name(self): ...
    @property
    def business_contact_last_name(self): ...
    @property
    def business_contact_email(self): ...
    @property
    def business_contact_phone(self): ...
    @property
    def notification_email(self): ...
    @property
    def use_case_categories(self): ...
    @property
    def use_case_summary(self): ...
    @property
    def production_message_sample(self): ...
    @property
    def opt_in_image_urls(self): ...
    @property
    def opt_in_type(self): ...
    @property
    def message_volume(self): ...
    @property
    def additional_information(self): ...
    @property
    def tollfree_phone_number_sid(self): ...
    @property
    def status(self): ...
    @property
    def url(self): ...
    @property
    def resource_links(self): ...
    @property
    def external_reference_id(self): ...
    def fetch(self): ...
    def update(self, business_name=..., business_website=..., notification_email=..., use_case_categories=..., use_case_summary=..., production_message_sample=..., opt_in_image_urls=..., opt_in_type=..., message_volume=..., business_street_address=..., business_street_address2=..., business_city=..., business_state_province_region=..., business_postal_code=..., business_country=..., additional_information=..., business_contact_first_name=..., business_contact_last_name=..., business_contact_email=..., business_contact_phone=...): ...
