from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.numbers.v2.regulatory_compliance.bundle.bundle_copy import BundleCopyList as BundleCopyList
from twilio.rest.numbers.v2.regulatory_compliance.bundle.evaluation import EvaluationList as EvaluationList
from twilio.rest.numbers.v2.regulatory_compliance.bundle.item_assignment import ItemAssignmentList as ItemAssignmentList
from twilio.rest.numbers.v2.regulatory_compliance.bundle.replace_items import ReplaceItemsList as ReplaceItemsList

class BundleList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, friendly_name, email, status_callback=..., regulation_sid=..., iso_country=..., end_user_type=..., number_type=...): ...
    def stream(self, status=..., friendly_name=..., regulation_sid=..., iso_country=..., number_type=..., has_valid_until_date=..., sort_by=..., sort_direction=..., valid_until_date_before=..., valid_until_date=..., valid_until_date_after=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, status=..., friendly_name=..., regulation_sid=..., iso_country=..., number_type=..., has_valid_until_date=..., sort_by=..., sort_direction=..., valid_until_date_before=..., valid_until_date=..., valid_until_date_after=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, status=..., friendly_name=..., regulation_sid=..., iso_country=..., number_type=..., has_valid_until_date=..., sort_by=..., sort_direction=..., valid_until_date_before=..., valid_until_date=..., valid_until_date_after=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class BundlePage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class BundleContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def fetch(self): ...
    def update(self, status=..., status_callback=..., friendly_name=..., email=...): ...
    def delete(self): ...
    @property
    def evaluations(self): ...
    @property
    def item_assignments(self): ...
    @property
    def bundle_copies(self): ...
    @property
    def replace_items(self): ...

class BundleInstance(InstanceResource):
    class Status:
        DRAFT: str
        PENDING_REVIEW: str
        IN_REVIEW: str
        TWILIO_REJECTED: str
        TWILIO_APPROVED: str
        PROVISIONALLY_APPROVED: str
    class EndUserType:
        INDIVIDUAL: str
        BUSINESS: str
    class SortBy:
        VALID_UNTIL: str
        DATE_UPDATED: str
    class SortDirection:
        ASC: str
        DESC: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def regulation_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def status(self): ...
    @property
    def valid_until(self): ...
    @property
    def email(self): ...
    @property
    def status_callback(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def update(self, status=..., status_callback=..., friendly_name=..., email=...): ...
    def delete(self): ...
    @property
    def evaluations(self): ...
    @property
    def item_assignments(self): ...
    @property
    def bundle_copies(self): ...
    @property
    def replace_items(self): ...
