from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.preview.deployed_devices.fleet.certificate import CertificateList as CertificateList
from twilio.rest.preview.deployed_devices.fleet.deployment import DeploymentList as DeploymentList
from twilio.rest.preview.deployed_devices.fleet.device import DeviceList as DeviceList
from twilio.rest.preview.deployed_devices.fleet.key import KeyList as KeyList

class FleetList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, friendly_name=...): ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class FleetPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class FleetContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, friendly_name=..., default_deployment_sid=...): ...
    @property
    def devices(self): ...
    @property
    def deployments(self): ...
    @property
    def certificates(self): ...
    @property
    def keys(self): ...

class FleetInstance(InstanceResource):
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def url(self): ...
    @property
    def unique_name(self): ...
    @property
    def friendly_name(self): ...
    @property
    def account_sid(self): ...
    @property
    def default_deployment_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def delete(self): ...
    def update(self, friendly_name=..., default_deployment_sid=...): ...
    @property
    def devices(self): ...
    @property
    def deployments(self): ...
    @property
    def certificates(self): ...
    @property
    def keys(self): ...
