from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class ModelBuildList(ListResource):
    def __init__(self, version, assistant_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, status_callback=..., unique_name=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class ModelBuildPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class ModelBuildContext(InstanceContext):
    def __init__(self, version, assistant_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, unique_name=...): ...
    def delete(self): ...

class ModelBuildInstance(InstanceResource):
    class Status:
        ENQUEUED: str
        BUILDING: str
        COMPLETED: str
        FAILED: str
        CANCELED: str
    def __init__(self, version, payload, assistant_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def assistant_sid(self): ...
    @property
    def sid(self): ...
    @property
    def status(self): ...
    @property
    def unique_name(self): ...
    @property
    def url(self): ...
    @property
    def build_duration(self): ...
    @property
    def error_code(self): ...
    def fetch(self): ...
    def update(self, unique_name=...): ...
    def delete(self): ...
