from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.preview.understand.assistant.task.field import FieldList as FieldList
from twilio.rest.preview.understand.assistant.task.sample import SampleList as SampleList
from twilio.rest.preview.understand.assistant.task.task_actions import TaskActionsList as TaskActionsList
from twilio.rest.preview.understand.assistant.task.task_statistics import TaskStatisticsList as TaskStatisticsList

class TaskList(ListResource):
    def __init__(self, version, assistant_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def create(self, unique_name, friendly_name=..., actions=..., actions_url=...): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class TaskPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class TaskContext(InstanceContext):
    def __init__(self, version, assistant_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, friendly_name=..., unique_name=..., actions=..., actions_url=...): ...
    def delete(self): ...
    @property
    def fields(self): ...
    @property
    def samples(self): ...
    @property
    def task_actions(self): ...
    @property
    def statistics(self): ...

class TaskInstance(InstanceResource):
    def __init__(self, version, payload, assistant_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def friendly_name(self): ...
    @property
    def links(self): ...
    @property
    def assistant_sid(self): ...
    @property
    def sid(self): ...
    @property
    def unique_name(self): ...
    @property
    def actions_url(self): ...
    @property
    def url(self): ...
    def fetch(self): ...
    def update(self, friendly_name=..., unique_name=..., actions=..., actions_url=...): ...
    def delete(self): ...
    @property
    def fields(self): ...
    @property
    def samples(self): ...
    @property
    def task_actions(self): ...
    @property
    def statistics(self): ...
