from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from twilio.rest.serverless.v1.service.function.function_version.function_version_content import FunctionVersionContentList as FunctionVersionContentList

class FunctionVersionList(ListResource):
    def __init__(self, version, service_sid, function_sid) -> None: ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class FunctionVersionPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class FunctionVersionContext(InstanceContext):
    def __init__(self, version, service_sid, function_sid, sid) -> None: ...
    def fetch(self): ...
    @property
    def function_version_content(self): ...

class FunctionVersionInstance(InstanceResource):
    class Visibility:
        PUBLIC: str
        PRIVATE: str
        PROTECTED: str
    def __init__(self, version, payload, service_sid, function_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def function_sid(self): ...
    @property
    def path(self): ...
    @property
    def visibility(self): ...
    @property
    def date_created(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    @property
    def function_version_content(self): ...
