from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class ReservationList(ListResource):
    def __init__(self, version, workspace_sid, task_sid) -> None: ...
    def stream(self, reservation_status=..., worker_sid=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, reservation_status=..., worker_sid=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, reservation_status=..., worker_sid=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class ReservationPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class ReservationContext(InstanceContext):
    def __init__(self, version, workspace_sid, task_sid, sid) -> None: ...
    def fetch(self): ...
    def update(self, reservation_status=..., worker_activity_sid=..., instruction=..., dequeue_post_work_activity_sid=..., dequeue_from=..., dequeue_record=..., dequeue_timeout=..., dequeue_to=..., dequeue_status_callback_url=..., call_from=..., call_record=..., call_timeout=..., call_to=..., call_url=..., call_status_callback_url=..., call_accept=..., redirect_call_sid=..., redirect_accept=..., redirect_url=..., to=..., from_=..., status_callback=..., status_callback_method=..., status_callback_event=..., timeout=..., record=..., muted=..., beep=..., start_conference_on_enter=..., end_conference_on_exit=..., wait_url=..., wait_method=..., early_media=..., max_participants=..., conference_status_callback=..., conference_status_callback_method=..., conference_status_callback_event=..., conference_record=..., conference_trim=..., recording_channels=..., recording_status_callback=..., recording_status_callback_method=..., conference_recording_status_callback=..., conference_recording_status_callback_method=..., region=..., sip_auth_username=..., sip_auth_password=..., dequeue_status_callback_event=..., post_work_activity_sid=..., supervisor_mode=..., supervisor=..., end_conference_on_customer_exit=..., beep_on_customer_entrance=..., if_match=...): ...

class ReservationInstance(InstanceResource):
    class Status:
        PENDING: str
        ACCEPTED: str
        REJECTED: str
        TIMEOUT: str
        CANCELED: str
        RESCINDED: str
        WRAPPING: str
        COMPLETED: str
    class CallStatus:
        INITIATED: str
        RINGING: str
        ANSWERED: str
        COMPLETED: str
    class ConferenceEvent:
        START: str
        END: str
        JOIN: str
        LEAVE: str
        MUTE: str
        HOLD: str
        SPEAKER: str
    class SupervisorMode:
        MONITOR: str
        WHISPER: str
        BARGE: str
    def __init__(self, version, payload, workspace_sid, task_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def reservation_status(self): ...
    @property
    def sid(self): ...
    @property
    def task_sid(self): ...
    @property
    def worker_name(self): ...
    @property
    def worker_sid(self): ...
    @property
    def workspace_sid(self): ...
    @property
    def url(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def update(self, reservation_status=..., worker_activity_sid=..., instruction=..., dequeue_post_work_activity_sid=..., dequeue_from=..., dequeue_record=..., dequeue_timeout=..., dequeue_to=..., dequeue_status_callback_url=..., call_from=..., call_record=..., call_timeout=..., call_to=..., call_url=..., call_status_callback_url=..., call_accept=..., redirect_call_sid=..., redirect_accept=..., redirect_url=..., to=..., from_=..., status_callback=..., status_callback_method=..., status_callback_event=..., timeout=..., record=..., muted=..., beep=..., start_conference_on_enter=..., end_conference_on_exit=..., wait_url=..., wait_method=..., early_media=..., max_participants=..., conference_status_callback=..., conference_status_callback_method=..., conference_status_callback_event=..., conference_record=..., conference_trim=..., recording_channels=..., recording_status_callback=..., recording_status_callback_method=..., conference_recording_status_callback=..., conference_recording_status_callback_method=..., region=..., sip_auth_username=..., sip_auth_password=..., dequeue_status_callback_event=..., post_work_activity_sid=..., supervisor_mode=..., supervisor=..., end_conference_on_customer_exit=..., beep_on_customer_entrance=..., if_match=...): ...
