from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class SupportingDocumentList(ListResource):
    def __init__(self, version) -> None: ...
    def create(self, friendly_name, type, attributes=...): ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class SupportingDocumentPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class SupportingDocumentContext(InstanceContext):
    def __init__(self, version, sid) -> None: ...
    def fetch(self): ...
    def update(self, friendly_name=..., attributes=...): ...
    def delete(self): ...

class SupportingDocumentInstance(InstanceResource):
    class Status:
        DRAFT: str
        PENDING_REVIEW: str
        REJECTED: str
        APPROVED: str
        EXPIRED: str
        PROVISIONALLY_APPROVED: str
    def __init__(self, version, payload, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def mime_type(self): ...
    @property
    def status(self): ...
    @property
    def type(self): ...
    @property
    def attributes(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    def fetch(self): ...
    def update(self, friendly_name=..., attributes=...): ...
    def delete(self): ...
