from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class WebhookList(ListResource):
    def __init__(self, version, service_sid) -> None: ...
    def create(self, friendly_name, event_types, webhook_url, status=..., version=...): ...
    def stream(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class WebhookPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class WebhookContext(InstanceContext):
    def __init__(self, version, service_sid, sid) -> None: ...
    def update(self, friendly_name=..., event_types=..., webhook_url=..., status=..., version=...): ...
    def delete(self): ...
    def fetch(self): ...

class WebhookInstance(InstanceResource):
    class Status:
        ENABLED: str
        DISABLED: str
    class Version:
        V1: str
        V2: str
    class Methods:
        GET: str
        POST: str
    def __init__(self, version, payload, service_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def sid(self): ...
    @property
    def service_sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def friendly_name(self): ...
    @property
    def event_types(self): ...
    @property
    def status(self): ...
    @property
    def version(self): ...
    @property
    def webhook_url(self): ...
    @property
    def webhook_method(self): ...
    @property
    def date_created(self): ...
    @property
    def date_updated(self): ...
    @property
    def url(self): ...
    def update(self, friendly_name=..., event_types=..., webhook_url=..., status=..., version=...): ...
    def delete(self): ...
    def fetch(self): ...
