from _typeshed import Incomplete
from twilio.base import deserialize as deserialize, serialize as serialize, values as values
from twilio.base.instance_context import InstanceContext as InstanceContext
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page

class RoomRecordingList(ListResource):
    def __init__(self, version, room_sid) -> None: ...
    def stream(self, status=..., source_sid=..., date_created_after=..., date_created_before=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def list(self, status=..., source_sid=..., date_created_after=..., date_created_before=..., limit: Incomplete | None = ..., page_size: Incomplete | None = ...): ...
    def page(self, status=..., source_sid=..., date_created_after=..., date_created_before=..., page_token=..., page_number=..., page_size=...): ...
    def get_page(self, target_url): ...
    def get(self, sid): ...
    def __call__(self, sid): ...

class RoomRecordingPage(Page):
    def __init__(self, version, response, solution) -> None: ...
    def get_instance(self, payload): ...

class RoomRecordingContext(InstanceContext):
    def __init__(self, version, room_sid, sid) -> None: ...
    def fetch(self): ...
    def delete(self): ...

class RoomRecordingInstance(InstanceResource):
    class Status:
        PROCESSING: str
        COMPLETED: str
        DELETED: str
        FAILED: str
    class Type:
        AUDIO: str
        VIDEO: str
        DATA: str
    class Format:
        MKA: str
        MKV: str
    class Codec:
        VP8: str
        H264: str
        OPUS: str
        PCMU: str
    def __init__(self, version, payload, room_sid, sid: Incomplete | None = ...) -> None: ...
    @property
    def account_sid(self): ...
    @property
    def status(self): ...
    @property
    def date_created(self): ...
    @property
    def sid(self): ...
    @property
    def source_sid(self): ...
    @property
    def size(self): ...
    @property
    def url(self): ...
    @property
    def type(self): ...
    @property
    def duration(self): ...
    @property
    def container_format(self): ...
    @property
    def codec(self): ...
    @property
    def grouping_sids(self): ...
    @property
    def track_name(self): ...
    @property
    def offset(self): ...
    @property
    def media_external_location(self): ...
    @property
    def room_sid(self): ...
    @property
    def links(self): ...
    def fetch(self): ...
    def delete(self): ...
