from twilio.base import deserialize as deserialize, values as values
from twilio.base.instance_resource import InstanceResource as InstanceResource
from twilio.base.list_resource import ListResource as ListResource
from twilio.base.page import Page as Page
from typing import Any, Optional

class DataSessionList(ListResource):
    def __init__(self, version: Any, sim_sid: Any) -> None: ...
    def stream(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def list(self, limit: Optional[Any] = ..., page_size: Optional[Any] = ...): ...
    def page(self, page_token: Any = ..., page_number: Any = ..., page_size: Any = ...): ...
    def get_page(self, target_url: Any): ...

class DataSessionPage(Page):
    def __init__(self, version: Any, response: Any, solution: Any) -> None: ...
    def get_instance(self, payload: Any): ...

class DataSessionInstance(InstanceResource):
    def __init__(self, version: Any, payload: Any, sim_sid: Any) -> None: ...
    @property
    def sid(self): ...
    @property
    def sim_sid(self): ...
    @property
    def account_sid(self): ...
    @property
    def radio_link(self): ...
    @property
    def operator_mcc(self): ...
    @property
    def operator_mnc(self): ...
    @property
    def operator_country(self): ...
    @property
    def operator_name(self): ...
    @property
    def cell_id(self): ...
    @property
    def cell_location_estimate(self): ...
    @property
    def packets_uploaded(self): ...
    @property
    def packets_downloaded(self): ...
    @property
    def last_updated(self): ...
    @property
    def start(self): ...
    @property
    def end(self): ...
    @property
    def imei(self): ...
